import { initPanelComponentToken as n, initPickerPanelToken as l, genPanelStyle as o } from "../../date-picker/style/index.mjs";
import { resetComponent as g } from "../../style/index.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useCacheToken.mjs";
import "react";
import "../../../../rc-util/es/warning.mjs";
import "../../../../@ant-design/cssinjs/es/StyleContext.mjs";
import "../../../../@ant-design/cssinjs/es/theme/createTheme.mjs";
import "../../../../@ant-design/cssinjs/es/theme/ThemeCache.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useCompatibleInsertionEffect.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useEffectCleanupRegister.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useHMR.mjs";
import "../../../../@ant-design/cssinjs/es/transformers/legacyLogicalProperties.mjs";
import p from "../../theme/util/genComponentStyleHook.mjs";
import { merge as c } from "../../theme/util/statistic.mjs";
const h = (i) => {
  const {
    calendarCls: e,
    componentCls: t,
    fullBg: r,
    fullPanelBg: d,
    itemActiveBg: a
  } = i;
  return {
    [e]: Object.assign(Object.assign(Object.assign({}, o(i)), g(i)), {
      background: r,
      "&-rtl": {
        direction: "rtl"
      },
      [`${e}-header`]: {
        display: "flex",
        justifyContent: "flex-end",
        padding: `${i.paddingSM}px 0`,
        [`${e}-year-select`]: {
          minWidth: i.yearControlWidth
        },
        [`${e}-month-select`]: {
          minWidth: i.monthControlWidth,
          marginInlineStart: i.marginXS
        },
        [`${e}-mode-switch`]: {
          marginInlineStart: i.marginXS
        }
      }
    }),
    [`${e} ${t}-panel`]: {
      background: d,
      border: 0,
      borderTop: `${i.lineWidth}px ${i.lineType} ${i.colorSplit}`,
      borderRadius: 0,
      [`${t}-month-panel, ${t}-date-panel`]: {
        width: "auto"
      },
      [`${t}-body`]: {
        padding: `${i.paddingXS}px 0`
      },
      [`${t}-content`]: {
        width: "100%"
      }
    },
    [`${e}-mini`]: {
      borderRadius: i.borderRadiusLG,
      [`${e}-header`]: {
        paddingInlineEnd: i.paddingXS,
        paddingInlineStart: i.paddingXS
      },
      [`${t}-panel`]: {
        borderRadius: `0 0 ${i.borderRadiusLG}px ${i.borderRadiusLG}px`
      },
      [`${t}-content`]: {
        height: i.miniContentHeight,
        th: {
          height: "auto",
          padding: 0,
          lineHeight: `${i.weekHeight}px`
        }
      },
      [`${t}-cell::before`]: {
        pointerEvents: "none"
      }
    },
    [`${e}${e}-full`]: {
      [`${t}-panel`]: {
        display: "block",
        width: "100%",
        textAlign: "end",
        background: r,
        border: 0,
        [`${t}-body`]: {
          "th, td": {
            padding: 0
          },
          th: {
            height: "auto",
            paddingInlineEnd: i.paddingSM,
            paddingBottom: i.paddingXXS,
            lineHeight: `${i.weekHeight}px`
          }
        }
      },
      [`${t}-cell`]: {
        "&::before": {
          display: "none"
        },
        "&:hover": {
          [`${e}-date`]: {
            background: i.controlItemBgHover
          }
        },
        [`${e}-date-today::before`]: {
          display: "none"
        },
        // >>> Selected
        [`&-in-view${t}-cell-selected`]: {
          [`${e}-date, ${e}-date-today`]: {
            background: a
          }
        },
        "&-selected, &-selected:hover": {
          [`${e}-date, ${e}-date-today`]: {
            [`${e}-date-value`]: {
              color: i.colorPrimary
            }
          }
        }
      },
      [`${e}-date`]: {
        display: "block",
        width: "auto",
        height: "auto",
        margin: `0 ${i.marginXS / 2}px`,
        padding: `${i.paddingXS / 2}px ${i.paddingXS}px 0`,
        border: 0,
        borderTop: `${i.lineWidthBold}px ${i.lineType} ${i.colorSplit}`,
        borderRadius: 0,
        transition: `background ${i.motionDurationSlow}`,
        "&-value": {
          lineHeight: `${i.dateValueHeight}px`,
          transition: `color ${i.motionDurationSlow}`
        },
        "&-content": {
          position: "static",
          width: "auto",
          height: i.dateContentHeight,
          overflowY: "auto",
          color: i.colorText,
          lineHeight: i.lineHeight,
          textAlign: "start"
        },
        "&-today": {
          borderColor: i.colorPrimary,
          [`${e}-date-value`]: {
            color: i.colorText
          }
        }
      }
    },
    [`@media only screen and (max-width: ${i.screenXS}px) `]: {
      [`${e}`]: {
        [`${e}-header`]: {
          display: "block",
          [`${e}-year-select`]: {
            width: "50%"
          },
          [`${e}-month-select`]: {
            width: `calc(50% - ${i.paddingXS}px)`
          },
          [`${e}-mode-switch`]: {
            width: "100%",
            marginTop: i.marginXS,
            marginInlineStart: 0,
            "> label": {
              width: "50%",
              textAlign: "center"
            }
          }
        }
      }
    }
  };
}, B = p("Calendar", (i) => {
  const e = `${i.componentCls}-calendar`, t = c(i, l(i), n(i), {
    calendarCls: e,
    pickerCellInnerCls: `${i.componentCls}-cell-inner`,
    dateValueHeight: i.controlHeightSM,
    weekHeight: i.controlHeightSM * 0.75,
    dateContentHeight: (i.fontSizeSM * i.lineHeightSM + i.marginXS) * 3 + i.lineWidth * 2
  });
  return [h(t)];
}, (i) => ({
  fullBg: i.colorBgContainer,
  fullPanelBg: i.colorBgContainer,
  itemActiveBg: i.controlItemBgActive,
  yearControlWidth: 80,
  monthControlWidth: 70,
  miniContentHeight: 256
}));
export {
  B as default,
  h as genCalendarStyles
};
