import { initComponentToken as re, initInputToken as ne, genActiveStyle as V, genHoverStyle as te, genBasicInputStyle as oe } from "../../input/style/index.mjs";
import { resetComponent as K, textEllipsis as ie } from "../../style/index.mjs";
import { genCompactItemStyle as ae } from "../../style/compact-item.mjs";
import { initMoveMotion as Z } from "../../style/motion/move.mjs";
import { slideDownIn as le, slideUpIn as de, slideDownOut as se, slideUpOut as ce, initSlideMotion as ee } from "../../style/motion/slide.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useCacheToken.mjs";
import "react";
import "../../../../rc-util/es/warning.mjs";
import "../../../../@ant-design/cssinjs/es/StyleContext.mjs";
import "../../../../@ant-design/cssinjs/es/theme/createTheme.mjs";
import "../../../../@ant-design/cssinjs/es/theme/ThemeCache.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useCompatibleInsertionEffect.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useEffectCleanupRegister.mjs";
import "../../../../@ant-design/cssinjs/es/hooks/useHMR.mjs";
import "../../../../@ant-design/cssinjs/es/transformers/legacyLogicalProperties.mjs";
import pe from "../../theme/util/genComponentStyleHook.mjs";
import { merge as J } from "../../theme/util/statistic.mjs";
import { roundedArrow as ge } from "../../style/roundedArrow.mjs";
import { TinyColor as X } from "../../../../@ctrl/tinycolor/dist/module/index.mjs";
const U = (n, e, r, t) => {
  const {
    lineHeight: l
  } = n, o = Math.floor(r * l) + 2, i = Math.max((e - o) / 2, 0), d = Math.max(e - o - i, 0);
  return {
    padding: `${i}px ${t}px ${d}px`
  };
}, $e = (n) => {
  const {
    componentCls: e,
    pickerCellCls: r,
    pickerCellInnerCls: t,
    cellHeight: l,
    motionDurationSlow: o,
    borderRadiusSM: i,
    motionDurationMid: d,
    cellHoverBg: s,
    lineWidth: $,
    lineType: C,
    colorPrimary: a,
    cellActiveWithRangeBg: h,
    colorTextLightSolid: S,
    controlHeightSM: w,
    cellRangeBorderColor: m,
    pickerCellBorderGap: p,
    cellHoverWithRangeBg: u,
    cellWidth: f,
    colorTextDisabled: g,
    cellBgDisabled: v
  } = n;
  return {
    "&::before": {
      position: "absolute",
      top: "50%",
      insetInlineStart: 0,
      insetInlineEnd: 0,
      zIndex: 1,
      height: l,
      transform: "translateY(-50%)",
      transition: `all ${o}`,
      content: '""'
    },
    // >>> Default
    [t]: {
      position: "relative",
      zIndex: 2,
      display: "inline-block",
      minWidth: l,
      height: l,
      lineHeight: `${l}px`,
      borderRadius: i,
      transition: `background ${d}, border ${d}`
    },
    "&-range-hover-start, &-range-hover-end": {
      [t]: {
        borderStartEndRadius: 0,
        borderEndEndRadius: 0
      }
    },
    // >>> Hover
    [`&:hover:not(${r}-in-view),
    &:hover:not(${r}-selected):not(${r}-range-start):not(${r}-range-end):not(${r}-range-hover-start):not(${r}-range-hover-end)`]: {
      [t]: {
        background: s
      }
    },
    // >>> Today
    [`&-in-view${r}-today ${t}`]: {
      "&::before": {
        position: "absolute",
        top: 0,
        insetInlineEnd: 0,
        bottom: 0,
        insetInlineStart: 0,
        zIndex: 1,
        border: `${$}px ${C} ${a}`,
        borderRadius: i,
        content: '""'
      }
    },
    // >>> In Range
    [`&-in-view${r}-in-range`]: {
      position: "relative",
      "&::before": {
        background: h
      }
    },
    // >>> Selected
    [`&-in-view${r}-selected ${t},
      &-in-view${r}-range-start ${t},
      &-in-view${r}-range-end ${t}`]: {
      color: S,
      background: a
    },
    [`&-in-view${r}-range-start:not(${r}-range-start-single),
      &-in-view${r}-range-end:not(${r}-range-end-single)`]: {
      "&::before": {
        background: h
      }
    },
    [`&-in-view${r}-range-start::before`]: {
      insetInlineStart: "50%"
    },
    [`&-in-view${r}-range-end::before`]: {
      insetInlineEnd: "50%"
    },
    // >>> Range Hover
    [`&-in-view${r}-range-hover-start:not(${r}-in-range):not(${r}-range-start):not(${r}-range-end),
      &-in-view${r}-range-hover-end:not(${r}-in-range):not(${r}-range-start):not(${r}-range-end),
      &-in-view${r}-range-hover-start${r}-range-start-single,
      &-in-view${r}-range-hover-start${r}-range-start${r}-range-end${r}-range-end-near-hover,
      &-in-view${r}-range-hover-end${r}-range-start${r}-range-end${r}-range-start-near-hover,
      &-in-view${r}-range-hover-end${r}-range-end-single,
      &-in-view${r}-range-hover:not(${r}-in-range)`]: {
      "&::after": {
        position: "absolute",
        top: "50%",
        zIndex: 0,
        height: w,
        borderTop: `${$}px dashed ${m}`,
        borderBottom: `${$}px dashed ${m}`,
        transform: "translateY(-50%)",
        transition: `all ${o}`,
        content: '""'
      }
    },
    // Add space for stash
    "&-range-hover-start::after,\n      &-range-hover-end::after,\n      &-range-hover::after": {
      insetInlineEnd: 0,
      insetInlineStart: p
    },
    // Hover with in range
    [`&-in-view${r}-in-range${r}-range-hover::before,
      &-in-view${r}-in-range${r}-range-hover-start::before,
      &-in-view${r}-in-range${r}-range-hover-end::before,
      &-in-view${r}-range-start${r}-range-hover::before,
      &-in-view${r}-range-end${r}-range-hover::before,
      &-in-view${r}-range-start:not(${r}-range-start-single)${r}-range-hover-start::before,
      &-in-view${r}-range-end:not(${r}-range-end-single)${r}-range-hover-end::before,
      ${e}-panel
      > :not(${e}-date-panel)
      &-in-view${r}-in-range${r}-range-hover-start::before,
      ${e}-panel
      > :not(${e}-date-panel)
      &-in-view${r}-in-range${r}-range-hover-end::before`]: {
      background: u
    },
    // range start border-radius
    [`&-in-view${r}-range-start:not(${r}-range-start-single):not(${r}-range-end) ${t}`]: {
      borderStartStartRadius: i,
      borderEndStartRadius: i,
      borderStartEndRadius: 0,
      borderEndEndRadius: 0
    },
    // range end border-radius
    [`&-in-view${r}-range-end:not(${r}-range-end-single):not(${r}-range-start) ${t}`]: {
      borderStartStartRadius: 0,
      borderEndStartRadius: 0,
      borderStartEndRadius: i,
      borderEndEndRadius: i
    },
    [`&-range-hover${r}-range-end::after`]: {
      insetInlineStart: "50%"
    },
    // Edge start
    [`tr > &-in-view${r}-range-hover:first-child::after,
      tr > &-in-view${r}-range-hover-end:first-child::after,
      &-in-view${r}-start${r}-range-hover-edge-start${r}-range-hover-edge-start-near-range::after,
      &-in-view${r}-range-hover-edge-start:not(${r}-range-hover-edge-start-near-range)::after,
      &-in-view${r}-range-hover-start::after`]: {
      insetInlineStart: (f - l) / 2,
      borderInlineStart: `${$}px dashed ${m}`,
      borderStartStartRadius: i,
      borderEndStartRadius: i
    },
    // Edge end
    [`tr > &-in-view${r}-range-hover:last-child::after,
      tr > &-in-view${r}-range-hover-start:last-child::after,
      &-in-view${r}-end${r}-range-hover-edge-end${r}-range-hover-edge-end-near-range::after,
      &-in-view${r}-range-hover-edge-end:not(${r}-range-hover-edge-end-near-range)::after,
      &-in-view${r}-range-hover-end::after`]: {
      insetInlineEnd: (f - l) / 2,
      borderInlineEnd: `${$}px dashed ${m}`,
      borderStartEndRadius: i,
      borderEndEndRadius: i
    },
    // >>> Disabled
    "&-disabled": {
      color: g,
      pointerEvents: "none",
      [t]: {
        background: "transparent"
      },
      "&::before": {
        background: v
      }
    },
    [`&-disabled${r}-today ${t}::before`]: {
      borderColor: g
    }
  };
}, he = (n) => {
  const {
    componentCls: e,
    pickerCellCls: r,
    pickerCellInnerCls: t,
    pickerYearMonthCellWidth: l,
    pickerControlIconSize: o,
    cellWidth: i,
    paddingSM: d,
    paddingXS: s,
    paddingXXS: $,
    colorBgContainer: C,
    lineWidth: a,
    lineType: h,
    borderRadiusLG: S,
    colorPrimary: w,
    colorTextHeading: m,
    colorSplit: p,
    pickerControlIconBorderWidth: u,
    colorIcon: f,
    textHeight: g,
    motionDurationMid: v,
    colorIconHover: B,
    fontWeightStrong: G,
    cellHeight: y,
    pickerCellPaddingVertical: E,
    colorTextDisabled: x,
    colorText: k,
    fontSize: P,
    cellHoverWithRangeBg: Y,
    motionDurationSlow: T,
    withoutTimeCellHeight: q,
    pickerQuarterPanelContentHeight: N,
    colorLink: A,
    colorLinkActive: F,
    colorLinkHover: Q,
    cellRangeBorderColor: b,
    borderRadiusSM: c,
    colorTextLightSolid: M,
    cellHoverBg: O,
    timeColumnHeight: R,
    timeColumnWidth: H,
    timeCellHeight: I,
    controlItemBgActive: W,
    marginXXS: D,
    pickerDatePanelPaddingHorizontal: j
  } = n, _ = i * 7 + j * 2, z = (_ - s * 2) / 3 - l - d, L = (_ - s * 2) / 4 - l;
  return {
    [e]: {
      "&-panel": {
        display: "inline-flex",
        flexDirection: "column",
        textAlign: "center",
        background: C,
        border: `${a}px ${h} ${p}`,
        borderRadius: S,
        outline: "none",
        "&-focused": {
          borderColor: w
        },
        "&-rtl": {
          direction: "rtl",
          [`${e}-prev-icon,
              ${e}-super-prev-icon`]: {
            transform: "rotate(45deg)"
          },
          [`${e}-next-icon,
              ${e}-super-next-icon`]: {
            transform: "rotate(-135deg)"
          }
        }
      },
      // ========================================================
      // =                     Shared Panel                     =
      // ========================================================
      "&-decade-panel,\n        &-year-panel,\n        &-quarter-panel,\n        &-month-panel,\n        &-week-panel,\n        &-date-panel,\n        &-time-panel": {
        display: "flex",
        flexDirection: "column",
        width: _
      },
      // ======================= Header =======================
      "&-header": {
        display: "flex",
        padding: `0 ${s}px`,
        color: m,
        borderBottom: `${a}px ${h} ${p}`,
        "> *": {
          flex: "none"
        },
        button: {
          padding: 0,
          color: f,
          lineHeight: `${g}px`,
          background: "transparent",
          border: 0,
          cursor: "pointer",
          transition: `color ${v}`,
          fontSize: "inherit"
        },
        "> button": {
          minWidth: "1.6em",
          fontSize: P,
          "&:hover": {
            color: B
          }
        },
        "&-view": {
          flex: "auto",
          fontWeight: G,
          lineHeight: `${g}px`,
          button: {
            color: "inherit",
            fontWeight: "inherit",
            verticalAlign: "top",
            "&:not(:first-child)": {
              marginInlineStart: s
            },
            "&:hover": {
              color: w
            }
          }
        }
      },
      // Arrow button
      "&-prev-icon,\n        &-next-icon,\n        &-super-prev-icon,\n        &-super-next-icon": {
        position: "relative",
        display: "inline-block",
        width: o,
        height: o,
        "&::before": {
          position: "absolute",
          top: 0,
          insetInlineStart: 0,
          display: "inline-block",
          width: o,
          height: o,
          border: "0 solid currentcolor",
          borderBlockStartWidth: u,
          borderBlockEndWidth: 0,
          borderInlineStartWidth: u,
          borderInlineEndWidth: 0,
          content: '""'
        }
      },
      "&-super-prev-icon,\n        &-super-next-icon": {
        "&::after": {
          position: "absolute",
          top: Math.ceil(o / 2),
          insetInlineStart: Math.ceil(o / 2),
          display: "inline-block",
          width: o,
          height: o,
          border: "0 solid currentcolor",
          borderBlockStartWidth: u,
          borderBlockEndWidth: 0,
          borderInlineStartWidth: u,
          borderInlineEndWidth: 0,
          content: '""'
        }
      },
      "&-prev-icon,\n        &-super-prev-icon": {
        transform: "rotate(-45deg)"
      },
      "&-next-icon,\n        &-super-next-icon": {
        transform: "rotate(135deg)"
      },
      // ======================== Body ========================
      "&-content": {
        width: "100%",
        tableLayout: "fixed",
        borderCollapse: "collapse",
        "th, td": {
          position: "relative",
          minWidth: y,
          fontWeight: "normal"
        },
        th: {
          height: y + E * 2,
          color: k,
          verticalAlign: "middle"
        }
      },
      "&-cell": Object.assign({
        padding: `${E}px 0`,
        color: x,
        cursor: "pointer",
        // In view
        "&-in-view": {
          color: k
        }
      }, $e(n)),
      // DatePanel only
      [`&-date-panel ${e}-cell-in-view${e}-cell-in-range${e}-cell-range-hover-start ${t},
        &-date-panel ${e}-cell-in-view${e}-cell-in-range${e}-cell-range-hover-end ${t}`]: {
        "&::after": {
          position: "absolute",
          top: 0,
          bottom: 0,
          zIndex: -1,
          background: Y,
          transition: `all ${T}`,
          content: '""'
        }
      },
      [`&-date-panel
        ${e}-cell-in-view${e}-cell-in-range${e}-cell-range-hover-start
        ${t}::after`]: {
        insetInlineEnd: -(i - y) / 2,
        insetInlineStart: 0
      },
      [`&-date-panel ${e}-cell-in-view${e}-cell-in-range${e}-cell-range-hover-end ${t}::after`]: {
        insetInlineEnd: 0,
        insetInlineStart: -(i - y) / 2
      },
      // Hover with range start & end
      [`&-range-hover${e}-range-start::after`]: {
        insetInlineEnd: "50%"
      },
      "&-decade-panel,\n        &-year-panel,\n        &-quarter-panel,\n        &-month-panel": {
        [`${e}-content`]: {
          height: q * 4
        },
        [t]: {
          padding: `0 ${s}px`
        }
      },
      "&-quarter-panel": {
        [`${e}-content`]: {
          height: N
        },
        // Quarter Panel Special Style
        [`${e}-cell-range-hover-start::after`]: {
          insetInlineStart: L,
          borderInlineStart: `${a}px dashed ${b}`,
          [`${e}-panel-rtl &`]: {
            insetInlineEnd: L,
            borderInlineEnd: `${a}px dashed ${b}`
          }
        },
        [`${e}-cell-range-hover-end::after`]: {
          insetInlineEnd: L,
          borderInlineEnd: `${a}px dashed ${b}`,
          [`${e}-panel-rtl &`]: {
            insetInlineStart: L,
            borderInlineStart: `${a}px dashed ${b}`
          }
        }
      },
      // ======================== Footer ========================
      [`&-panel ${e}-footer`]: {
        borderTop: `${a}px ${h} ${p}`
      },
      "&-footer": {
        width: "min-content",
        minWidth: "100%",
        lineHeight: `${g - 2 * a}px`,
        textAlign: "center",
        "&-extra": {
          padding: `0 ${d}px`,
          lineHeight: `${g - 2 * a}px`,
          textAlign: "start",
          "&:not(:last-child)": {
            borderBottom: `${a}px ${h} ${p}`
          }
        }
      },
      "&-now": {
        textAlign: "start"
      },
      "&-today-btn": {
        color: A,
        "&:hover": {
          color: Q
        },
        "&:active": {
          color: F
        },
        [`&${e}-today-btn-disabled`]: {
          color: x,
          cursor: "not-allowed"
        }
      },
      // ========================================================
      // =                       Special                        =
      // ========================================================
      // ===================== Decade Panel =====================
      "&-decade-panel": {
        [t]: {
          padding: `0 ${s / 2}px`
        },
        [`${e}-cell::before`]: {
          display: "none"
        }
      },
      // ============= Year & Quarter & Month Panel =============
      "&-year-panel,\n        &-quarter-panel,\n        &-month-panel": {
        [`${e}-body`]: {
          padding: `0 ${s}px`
        },
        [t]: {
          width: l
        },
        [`${e}-cell-range-hover-start::after`]: {
          borderStartStartRadius: c,
          borderEndStartRadius: c,
          borderStartEndRadius: 0,
          borderEndEndRadius: 0,
          [`${e}-panel-rtl &`]: {
            borderStartStartRadius: 0,
            borderEndStartRadius: 0,
            borderStartEndRadius: c,
            borderEndEndRadius: c
          }
        },
        [`${e}-cell-range-hover-end::after`]: {
          borderStartStartRadius: 0,
          borderEndStartRadius: 0,
          borderStartEndRadius: c,
          borderEndEndRadius: c,
          [`${e}-panel-rtl &`]: {
            borderStartStartRadius: c,
            borderEndStartRadius: c,
            borderStartEndRadius: 0,
            borderEndEndRadius: 0
          }
        }
      },
      "&-year-panel,\n        &-month-panel": {
        [`${e}-cell-range-hover-start::after`]: {
          insetInlineStart: z,
          borderInlineStart: `${a}px dashed ${b}`,
          [`${e}-panel-rtl &`]: {
            insetInlineEnd: z,
            borderInlineEnd: `${a}px dashed ${b}`
          }
        },
        [`${e}-cell-range-hover-end::after`]: {
          insetInlineEnd: z,
          borderInlineEnd: `${a}px dashed ${b}`,
          [`${e}-panel-rtl &`]: {
            insetInlineStart: z,
            borderInlineStart: `${a}px dashed ${b}`
          }
        }
      },
      // ====================== Week Panel ======================
      "&-week-panel": {
        [`${e}-body`]: {
          padding: `${s}px ${d}px`
        },
        // Clear cell style
        [`${e}-cell`]: {
          [`&:hover ${t},
            &-selected ${t},
            ${t}`]: {
            background: "transparent !important"
          }
        },
        "&-row": {
          td: {
            "&:before": {
              transition: `background ${v}`
            },
            "&:first-child:before": {
              borderStartStartRadius: c,
              borderEndStartRadius: c
            },
            "&:last-child:before": {
              borderStartEndRadius: c,
              borderEndEndRadius: c
            }
          },
          "&:hover td": {
            "&:before": {
              background: O
            }
          },
          "&-range-start td,\n            &-range-end td,\n            &-selected td": {
            // Rise priority to override hover style
            [`&${r}`]: {
              "&:before": {
                background: w
              },
              [`&${e}-cell-week`]: {
                color: new X(M).setAlpha(0.5).toHexString()
              },
              [t]: {
                color: M
              }
            }
          },
          "&-range-hover td:before": {
            background: W
          }
        }
      },
      // ====================== Date Panel ======================
      "&-date-panel": {
        [`${e}-body`]: {
          padding: `${s}px ${j}px`
        },
        [`${e}-content`]: {
          width: i * 7,
          th: {
            width: i,
            boxSizing: "border-box",
            padding: 0
          }
        }
      },
      // ==================== Datetime Panel ====================
      "&-datetime-panel": {
        display: "flex",
        [`${e}-time-panel`]: {
          borderInlineStart: `${a}px ${h} ${p}`
        },
        [`${e}-date-panel,
          ${e}-time-panel`]: {
          transition: `opacity ${T}`
        },
        // Keyboard
        "&-active": {
          [`${e}-date-panel,
            ${e}-time-panel`]: {
            opacity: 0.3,
            "&-active": {
              opacity: 1
            }
          }
        }
      },
      // ====================== Time Panel ======================
      "&-time-panel": {
        width: "auto",
        minWidth: "auto",
        direction: "ltr",
        [`${e}-content`]: {
          display: "flex",
          flex: "auto",
          height: R
        },
        "&-column": {
          flex: "1 0 auto",
          width: H,
          margin: `${$}px 0`,
          padding: 0,
          overflowY: "hidden",
          textAlign: "start",
          listStyle: "none",
          transition: `background ${v}`,
          overflowX: "hidden",
          "&::-webkit-scrollbar": {
            width: 8,
            backgroundColor: "transparent"
          },
          "&::-webkit-scrollbar-thumb": {
            backgroundColor: n.colorTextTertiary,
            borderRadius: 4
          },
          // For Firefox
          "&": {
            scrollbarWidth: "thin",
            scrollbarColor: `${n.colorTextTertiary} transparent`
          },
          "&::after": {
            display: "block",
            height: R - I,
            content: '""'
          },
          "&:not(:first-child)": {
            borderInlineStart: `${a}px ${h} ${p}`
          },
          "&-active": {
            background: new X(W).setAlpha(0.2).toHexString()
          },
          "&:hover": {
            overflowY: "auto"
          },
          "> li": {
            margin: 0,
            padding: 0,
            [`&${e}-time-panel-cell`]: {
              marginInline: D,
              [`${e}-time-panel-cell-inner`]: {
                display: "block",
                width: H - 2 * D,
                height: I,
                margin: 0,
                paddingBlock: 0,
                paddingInlineEnd: 0,
                paddingInlineStart: (H - I) / 2,
                color: k,
                lineHeight: `${I}px`,
                borderRadius: c,
                cursor: "pointer",
                transition: `background ${v}`,
                "&:hover": {
                  background: O
                }
              },
              "&-selected": {
                [`${e}-time-panel-cell-inner`]: {
                  background: W
                }
              },
              "&-disabled": {
                [`${e}-time-panel-cell-inner`]: {
                  color: x,
                  background: "transparent",
                  cursor: "not-allowed"
                }
              }
            }
          }
        }
      },
      // https://github.com/ant-design/ant-design/issues/39227
      [`&-datetime-panel ${e}-time-panel-column:after`]: {
        height: R - I + $ * 2
      }
    }
  };
}, be = (n) => {
  const {
    componentCls: e,
    colorBgContainer: r,
    colorError: t,
    errorActiveShadow: l,
    colorWarning: o,
    warningActiveShadow: i,
    colorErrorHover: d,
    colorWarningHover: s
  } = n;
  return {
    [`${e}:not(${e}-disabled):not([disabled])`]: {
      [`&${e}-status-error`]: {
        backgroundColor: r,
        borderColor: t,
        "&:hover": {
          borderColor: d
        },
        [`&${e}-focused, &:focus`]: Object.assign({}, V(J(n, {
          activeBorderColor: t,
          activeShadow: l
        }))),
        [`${e}-active-bar`]: {
          background: t
        }
      },
      [`&${e}-status-warning`]: {
        backgroundColor: r,
        borderColor: o,
        "&:hover": {
          borderColor: s
        },
        [`&${e}-focused, &:focus`]: Object.assign({}, V(J(n, {
          activeBorderColor: o,
          activeShadow: i
        }))),
        [`${e}-active-bar`]: {
          background: o
        }
      }
    }
  };
}, ue = (n) => {
  const {
    componentCls: e,
    antCls: r,
    controlHeight: t,
    fontSize: l,
    paddingInline: o,
    colorBgContainer: i,
    lineWidth: d,
    lineType: s,
    colorBorder: $,
    borderRadius: C,
    motionDurationMid: a,
    colorBgContainerDisabled: h,
    colorTextDisabled: S,
    colorTextPlaceholder: w,
    controlHeightLG: m,
    fontSizeLG: p,
    controlHeightSM: u,
    paddingInlineSM: f,
    paddingXS: g,
    marginXS: v,
    colorTextDescription: B,
    lineWidthBold: G,
    lineHeight: y,
    colorPrimary: E,
    motionDurationSlow: x,
    zIndexPopup: k,
    paddingXXS: P,
    paddingSM: Y,
    textHeight: T,
    cellActiveWithRangeBg: q,
    colorPrimaryBorder: N,
    sizePopupArrow: A,
    borderRadiusXS: F,
    borderRadiusOuter: Q,
    colorBgElevated: b,
    borderRadiusLG: c,
    boxShadowSecondary: M,
    borderRadiusSM: O,
    colorSplit: R,
    cellHoverBg: H,
    presetsWidth: I,
    presetsMaxWidth: W,
    boxShadowPopoverArrow: D,
    colorTextQuaternary: j
  } = n;
  return [
    {
      [e]: Object.assign(Object.assign(Object.assign({}, K(n)), U(n, t, l, o)), {
        position: "relative",
        display: "inline-flex",
        alignItems: "center",
        background: i,
        lineHeight: 1,
        border: `${d}px ${s} ${$}`,
        borderRadius: C,
        transition: `border ${a}, box-shadow ${a}`,
        "&:hover": Object.assign({}, te(n)),
        [`&-focused${e}`]: Object.assign({}, V(n)),
        [`&${e}-disabled`]: {
          background: h,
          borderColor: $,
          cursor: "not-allowed",
          [`${e}-suffix`]: {
            color: j
          }
        },
        [`&${e}-borderless`]: {
          backgroundColor: "transparent !important",
          borderColor: "transparent !important",
          boxShadow: "none !important"
        },
        // ======================== Input =========================
        [`${e}-input`]: {
          position: "relative",
          display: "inline-flex",
          alignItems: "center",
          width: "100%",
          "> input": Object.assign(Object.assign({}, oe(n)), {
            flex: "auto",
            // Fix Firefox flex not correct:
            // https://github.com/ant-design/ant-design/pull/20023#issuecomment-564389553
            minWidth: 1,
            height: "auto",
            padding: 0,
            background: "transparent",
            border: 0,
            borderRadius: 0,
            fontFamily: "inherit",
            "&:focus": {
              boxShadow: "none"
            },
            "&[disabled]": {
              background: "transparent"
            }
          }),
          "&:hover": {
            [`${e}-clear`]: {
              opacity: 1
            }
          },
          "&-placeholder": {
            "> input": {
              color: w
            }
          }
        },
        // Size
        "&-large": Object.assign(Object.assign({}, U(n, m, p, o)), {
          [`${e}-input > input`]: {
            fontSize: p
          }
        }),
        "&-small": Object.assign({}, U(n, u, l, f)),
        [`${e}-suffix`]: {
          display: "flex",
          flex: "none",
          alignSelf: "center",
          marginInlineStart: g / 2,
          color: S,
          lineHeight: 1,
          pointerEvents: "none",
          "> *": {
            verticalAlign: "top",
            "&:not(:last-child)": {
              marginInlineEnd: v
            }
          }
        },
        [`${e}-clear`]: {
          position: "absolute",
          top: "50%",
          insetInlineEnd: 0,
          color: S,
          lineHeight: 1,
          background: i,
          transform: "translateY(-50%)",
          cursor: "pointer",
          opacity: 0,
          transition: `opacity ${a}, color ${a}`,
          "> *": {
            verticalAlign: "top"
          },
          "&:hover": {
            color: B
          }
        },
        [`${e}-separator`]: {
          position: "relative",
          display: "inline-block",
          width: "1em",
          height: p,
          color: S,
          fontSize: p,
          verticalAlign: "top",
          cursor: "default",
          [`${e}-focused &`]: {
            color: B
          },
          [`${e}-range-separator &`]: {
            [`${e}-disabled &`]: {
              cursor: "not-allowed"
            }
          }
        },
        // ======================== Range =========================
        "&-range": {
          position: "relative",
          display: "inline-flex",
          // Clear
          [`${e}-clear`]: {
            insetInlineEnd: o
          },
          "&:hover": {
            [`${e}-clear`]: {
              opacity: 1
            }
          },
          // Active bar
          [`${e}-active-bar`]: {
            bottom: -d,
            height: G,
            marginInlineStart: o,
            background: E,
            opacity: 0,
            transition: `all ${x} ease-out`,
            pointerEvents: "none"
          },
          [`&${e}-focused`]: {
            [`${e}-active-bar`]: {
              opacity: 1
            }
          },
          [`${e}-range-separator`]: {
            alignItems: "center",
            padding: `0 ${g}px`,
            lineHeight: 1
          },
          [`&${e}-small`]: {
            [`${e}-clear`]: {
              insetInlineEnd: f
            },
            [`${e}-active-bar`]: {
              marginInlineStart: f
            }
          }
        },
        // ======================= Dropdown =======================
        "&-dropdown": Object.assign(Object.assign(Object.assign({}, K(n)), he(n)), {
          position: "absolute",
          // Fix incorrect position of picker popup
          // https://github.com/ant-design/ant-design/issues/35590
          top: -9999,
          left: {
            _skip_check_: !0,
            value: -9999
          },
          zIndex: k,
          [`&${e}-dropdown-hidden`]: {
            display: "none"
          },
          [`&${e}-dropdown-placement-bottomLeft`]: {
            [`${e}-range-arrow`]: {
              top: 0,
              display: "block",
              transform: "translateY(-100%)"
            }
          },
          [`&${e}-dropdown-placement-topLeft`]: {
            [`${e}-range-arrow`]: {
              bottom: 0,
              display: "block",
              transform: "translateY(100%) rotate(180deg)"
            }
          },
          [`&${r}-slide-up-enter${r}-slide-up-enter-active${e}-dropdown-placement-topLeft,
          &${r}-slide-up-enter${r}-slide-up-enter-active${e}-dropdown-placement-topRight,
          &${r}-slide-up-appear${r}-slide-up-appear-active${e}-dropdown-placement-topLeft,
          &${r}-slide-up-appear${r}-slide-up-appear-active${e}-dropdown-placement-topRight`]: {
            animationName: le
          },
          [`&${r}-slide-up-enter${r}-slide-up-enter-active${e}-dropdown-placement-bottomLeft,
          &${r}-slide-up-enter${r}-slide-up-enter-active${e}-dropdown-placement-bottomRight,
          &${r}-slide-up-appear${r}-slide-up-appear-active${e}-dropdown-placement-bottomLeft,
          &${r}-slide-up-appear${r}-slide-up-appear-active${e}-dropdown-placement-bottomRight`]: {
            animationName: de
          },
          [`&${r}-slide-up-leave${r}-slide-up-leave-active${e}-dropdown-placement-topLeft,
          &${r}-slide-up-leave${r}-slide-up-leave-active${e}-dropdown-placement-topRight`]: {
            animationName: se
          },
          [`&${r}-slide-up-leave${r}-slide-up-leave-active${e}-dropdown-placement-bottomLeft,
          &${r}-slide-up-leave${r}-slide-up-leave-active${e}-dropdown-placement-bottomRight`]: {
            animationName: ce
          },
          // Time picker with additional style
          [`${e}-panel > ${e}-time-panel`]: {
            paddingTop: P
          },
          // ======================== Ranges ========================
          [`${e}-ranges`]: {
            marginBottom: 0,
            padding: `${P}px ${Y}px`,
            overflow: "hidden",
            lineHeight: `${T - 2 * d - g / 2}px`,
            textAlign: "start",
            listStyle: "none",
            display: "flex",
            justifyContent: "space-between",
            "> li": {
              display: "inline-block"
            },
            // https://github.com/ant-design/ant-design/issues/23687
            [`${e}-preset > ${r}-tag-blue`]: {
              color: E,
              background: q,
              borderColor: N,
              cursor: "pointer"
            },
            [`${e}-ok`]: {
              marginInlineStart: "auto"
            }
          },
          [`${e}-range-wrapper`]: {
            display: "flex",
            position: "relative"
          },
          [`${e}-range-arrow`]: Object.assign({
            position: "absolute",
            zIndex: 1,
            display: "none",
            marginInlineStart: o * 1.5,
            transition: `left ${x} ease-out`
          }, ge(A, F, Q, b, D)),
          [`${e}-panel-container`]: {
            overflow: "hidden",
            verticalAlign: "top",
            background: b,
            borderRadius: c,
            boxShadow: M,
            transition: `margin ${x}`,
            // ======================== Layout ========================
            [`${e}-panel-layout`]: {
              display: "flex",
              flexWrap: "nowrap",
              alignItems: "stretch"
            },
            // ======================== Preset ========================
            [`${e}-presets`]: {
              display: "flex",
              flexDirection: "column",
              minWidth: I,
              maxWidth: W,
              ul: {
                height: 0,
                flex: "auto",
                listStyle: "none",
                overflow: "auto",
                margin: 0,
                padding: g,
                borderInlineEnd: `${d}px ${s} ${R}`,
                li: Object.assign(Object.assign({}, ie), {
                  borderRadius: O,
                  paddingInline: g,
                  paddingBlock: (u - Math.round(l * y)) / 2,
                  cursor: "pointer",
                  transition: `all ${x}`,
                  "+ li": {
                    marginTop: v
                  },
                  "&:hover": {
                    background: H
                  }
                })
              }
            },
            // ======================== Panels ========================
            [`${e}-panels`]: {
              display: "inline-flex",
              flexWrap: "nowrap",
              direction: "ltr",
              [`${e}-panel`]: {
                borderWidth: `0 0 ${d}px`
              },
              "&:last-child": {
                [`${e}-panel`]: {
                  borderWidth: 0
                }
              }
            },
            [`${e}-panel`]: {
              verticalAlign: "top",
              background: "transparent",
              borderRadius: 0,
              borderWidth: 0,
              [`${e}-content,
            table`]: {
                textAlign: "center"
              },
              "&-focused": {
                borderColor: $
              }
            }
          }
        }),
        "&-dropdown-range": {
          padding: `${A * 2 / 3}px 0`,
          "&-hidden": {
            display: "none"
          }
        },
        "&-rtl": {
          direction: "rtl",
          [`${e}-separator`]: {
            transform: "rotate(180deg)"
          },
          [`${e}-footer`]: {
            "&-extra": {
              direction: "rtl"
            }
          }
        }
      })
    },
    // Follow code may reuse in other components
    ee(n, "slide-up"),
    ee(n, "slide-down"),
    Z(n, "move-up"),
    Z(n, "move-down")
  ];
}, ve = (n) => {
  const {
    componentCls: e,
    controlHeightLG: r,
    paddingXXS: t,
    padding: l
  } = n;
  return {
    pickerCellCls: `${e}-cell`,
    pickerCellInnerCls: `${e}-cell-inner`,
    pickerYearMonthCellWidth: r * 1.5,
    pickerQuarterPanelContentHeight: r * 1.4,
    pickerCellPaddingVertical: t + t / 2,
    pickerCellBorderGap: 2,
    pickerControlIconSize: 7,
    pickerControlIconBorderWidth: 1.5,
    pickerDatePanelPaddingHorizontal: l + t / 2
    // 18 in normal
  };
}, me = (n) => ({
  cellHoverBg: n.controlItemBgHover,
  cellActiveWithRangeBg: n.controlItemBgActive,
  cellHoverWithRangeBg: new X(n.colorPrimary).lighten(35).toHexString(),
  cellRangeBorderColor: new X(n.colorPrimary).lighten(20).toHexString(),
  cellBgDisabled: n.colorBgContainerDisabled,
  timeColumnWidth: n.controlHeightLG * 1.4,
  timeColumnHeight: 28 * 8,
  timeCellHeight: 28,
  cellWidth: n.controlHeightSM * 1.5,
  cellHeight: n.controlHeightSM,
  textHeight: n.controlHeightLG,
  withoutTimeCellHeight: n.controlHeightLG * 1.65
}), je = pe("DatePicker", (n) => {
  const e = J(ne(n), ve(n));
  return [
    ue(e),
    be(e),
    // =====================================================
    // ==             Space Compact                       ==
    // =====================================================
    ae(n, {
      focusElCls: `${n.componentCls}-focused`
    })
  ];
}, (n) => Object.assign(Object.assign(Object.assign({}, re(n)), me(n)), {
  presetsWidth: 120,
  presetsMaxWidth: 200,
  zIndexPopup: n.zIndexPopupBase + 50
}));
export {
  je as default,
  he as genPanelStyle,
  me as initPanelComponentToken,
  ve as initPickerPanelToken
};
