import * as l from "react";
import M from "../../../classnames/index.mjs";
import Ce from "../../../rc-select/es/Select.mjs";
import ge from "../../../rc-select/es/Option.mjs";
import be from "../../../rc-select/es/OptGroup.mjs";
import "../../../rc-select/es/BaseSelect.mjs";
import Oe from "../../../rc-util/es/omit.mjs";
import { useZIndex as we } from "../_util/hooks/useZIndex.mjs";
import { getTransitionName as ve } from "../_util/motion.mjs";
import Ne from "../_util/PurePanel.mjs";
import { getStatusClassNames as xe, getMergedStatus as Ie } from "../_util/statusUtils.mjs";
import { devUseWarning as _e } from "../_util/warning.mjs";
import "../config-provider/index.mjs";
import Ee from "../config-provider/defaultRenderEmpty.mjs";
import Pe from "../config-provider/DisabledContext.mjs";
import ye from "../config-provider/hooks/useSize.mjs";
import { FormItemInputContext as Me } from "../form/context.mjs";
import { useCompactItemContext as De } from "../space/Compact.mjs";
import je from "./style/index.mjs";
import We from "./useBuiltinPlacements.mjs";
import ze from "./useIcons.mjs";
import Te from "./useShowArrow.mjs";
import { ConfigContext as Be } from "../config-provider/context.mjs";
var Re = globalThis && globalThis.__rest || function(n, d) {
  var c = {};
  for (var e in n)
    Object.prototype.hasOwnProperty.call(n, e) && d.indexOf(e) < 0 && (c[e] = n[e]);
  if (n != null && typeof Object.getOwnPropertySymbols == "function")
    for (var i = 0, e = Object.getOwnPropertySymbols(n); i < e.length; i++)
      d.indexOf(e[i]) < 0 && Object.prototype.propertyIsEnumerable.call(n, e[i]) && (c[e[i]] = n[e[i]]);
  return c;
};
const D = "SECRET_COMBOBOX_MODE_DO_NOT_USE", j = (n, d) => {
  var c, e, {
    prefixCls: i,
    bordered: W = !0,
    className: z,
    rootClassName: w,
    getPopupContainer: T,
    popupClassName: B,
    dropdownClassName: v,
    listHeight: R = 256,
    placement: f,
    listItemHeight: F = 24,
    size: S,
    disabled: h,
    notFoundContent: N,
    status: $,
    builtinPlacements: A,
    dropdownMatchSelectWidth: x,
    popupMatchSelectWidth: C,
    direction: g,
    style: H,
    allowClear: I
  } = n, t = Re(n, ["prefixCls", "bordered", "className", "rootClassName", "getPopupContainer", "popupClassName", "dropdownClassName", "listHeight", "placement", "listItemHeight", "size", "disabled", "notFoundContent", "status", "builtinPlacements", "dropdownMatchSelectWidth", "popupMatchSelectWidth", "direction", "style", "allowClear"]);
  const {
    getPopupContainer: U,
    getPrefixCls: _,
    renderEmpty: b,
    direction: V,
    virtual: k,
    popupMatchSelectWidth: X,
    popupOverflow: G,
    select: r
  } = l.useContext(Be), o = _("select", i), L = _(), a = g ?? V, {
    compactSize: Y,
    compactItemClassnames: Z
  } = De(o, a), [q, E] = je(o), p = l.useMemo(() => {
    const {
      mode: s
    } = t;
    if (s !== "combobox")
      return s === D ? "combobox" : s;
  }, [t.mode]), J = p === "multiple" || p === "tags", K = Te(t.suffixIcon, t.showArrow), Q = (c = C ?? x) !== null && c !== void 0 ? c : X, {
    status: ee,
    hasFeedback: P,
    isFormItemInput: te,
    feedbackIcon: oe
  } = l.useContext(Me), ne = Ie(ee, $);
  let u;
  N !== void 0 ? u = N : p === "combobox" ? u = null : u = (b == null ? void 0 : b("Select")) || /* @__PURE__ */ l.createElement(Ee, {
    componentName: "Select"
  });
  const {
    suffixIcon: re,
    itemIcon: se,
    removeIcon: ie,
    clearIcon: le
  } = ze(Object.assign(Object.assign({}, t), {
    multiple: J,
    hasFeedback: P,
    feedbackIcon: oe,
    showSuffixIcon: K,
    prefixCls: o,
    showArrow: t.showArrow,
    componentName: "Select"
  })), ce = I === !0 ? {
    clearIcon: le
  } : I, ae = Oe(t, ["suffixIcon", "itemIcon"]), me = M(B || v, {
    [`${o}-dropdown-${a}`]: a === "rtl"
  }, w, E), y = ye((s) => {
    var O;
    return (O = S ?? Y) !== null && O !== void 0 ? O : s;
  }), de = l.useContext(Pe), pe = h ?? de, ue = M({
    [`${o}-lg`]: y === "large",
    [`${o}-sm`]: y === "small",
    [`${o}-rtl`]: a === "rtl",
    [`${o}-borderless`]: !W,
    [`${o}-in-form-item`]: te
  }, xe(o, ne, P), Z, r == null ? void 0 : r.className, z, w, E), fe = l.useMemo(() => f !== void 0 ? f : a === "rtl" ? "bottomRight" : "bottomLeft", [f, a]), Se = We(A, G);
  if (process.env.NODE_ENV !== "production") {
    const s = _e("Select");
    s.deprecated(!v, "dropdownClassName", "popupClassName"), s.deprecated(x === void 0, "dropdownMatchSelectWidth", "popupMatchSelectWidth"), process.env.NODE_ENV !== "production" && s(!("showArrow" in t), "deprecated", "`showArrow` is deprecated which will be removed in next major version. It will be a default behavior, you can hide it by setting `suffixIcon` to null.");
  }
  const [he] = we("SelectLike", (e = t.dropdownStyle) === null || e === void 0 ? void 0 : e.zIndex);
  return q(/* @__PURE__ */ l.createElement(Ce, Object.assign({
    ref: d,
    virtual: k,
    showSearch: r == null ? void 0 : r.showSearch
  }, ae, {
    style: Object.assign(Object.assign({}, r == null ? void 0 : r.style), H),
    dropdownMatchSelectWidth: Q,
    builtinPlacements: Se,
    transitionName: ve(L, "slide-up", t.transitionName),
    listHeight: R,
    listItemHeight: F,
    mode: p,
    prefixCls: o,
    placement: fe,
    direction: a,
    suffixIcon: re,
    menuItemSelectedIcon: se,
    removeIcon: ie,
    allowClear: ce,
    notFoundContent: u,
    className: ue,
    getPopupContainer: T || U,
    dropdownClassName: me,
    disabled: pe,
    dropdownStyle: Object.assign(Object.assign({}, t == null ? void 0 : t.dropdownStyle), {
      zIndex: he
    })
  })));
};
process.env.NODE_ENV !== "production" && (j.displayName = "Select");
const m = /* @__PURE__ */ l.forwardRef(j), Fe = Ne(m);
m.SECRET_COMBOBOX_MODE_DO_NOT_USE = D;
m.Option = ge;
m.OptGroup = be;
m._InternalPanelDoNotUseOrYouWillBeFired = Fe;
process.env.NODE_ENV !== "production" && (m.displayName = "Select");
const lt = m;
export {
  lt as default
};
