import { blue as d } from "../../../../@ant-design/colors/es/index.mjs";
import { textEllipsis as c, clearFix as p } from "../../style/index.mjs";
import { TinyColor as s } from "../../../../@ctrl/tinycolor/dist/module/index.mjs";
const m = (i) => {
  const {
    componentCls: e,
    iconCls: t,
    uploadThumbnailSize: l,
    uploadProgressOffset: a
  } = i, o = `${e}-list`, r = `${o}-item`;
  return {
    [`${e}-wrapper`]: {
      // ${listCls} 增加优先级
      [`
        ${o}${o}-picture,
        ${o}${o}-picture-card,
        ${o}${o}-picture-circle
      `]: {
        [r]: {
          position: "relative",
          height: l + i.lineWidth * 2 + i.paddingXS * 2,
          padding: i.paddingXS,
          border: `${i.lineWidth}px ${i.lineType} ${i.colorBorder}`,
          borderRadius: i.borderRadiusLG,
          "&:hover": {
            background: "transparent"
          },
          [`${r}-thumbnail`]: Object.assign(Object.assign({}, c), {
            width: l,
            height: l,
            lineHeight: `${l + i.paddingSM}px`,
            textAlign: "center",
            flex: "none",
            [t]: {
              fontSize: i.fontSizeHeading2,
              color: i.colorPrimary
            },
            img: {
              display: "block",
              width: "100%",
              height: "100%",
              overflow: "hidden"
            }
          }),
          [`${r}-progress`]: {
            bottom: a,
            width: `calc(100% - ${i.paddingSM * 2}px)`,
            marginTop: 0,
            paddingInlineStart: l + i.paddingXS
          }
        },
        [`${r}-error`]: {
          borderColor: i.colorError,
          // Adjust the color of the error icon : https://github.com/ant-design/ant-design/pull/24160
          [`${r}-thumbnail ${t}`]: {
            [`svg path[fill='${d[0]}']`]: {
              fill: i.colorErrorBg
            },
            [`svg path[fill='${d.primary}']`]: {
              fill: i.colorError
            }
          }
        },
        [`${r}-uploading`]: {
          borderStyle: "dashed",
          [`${r}-name`]: {
            marginBottom: a
          }
        }
      },
      [`${o}${o}-picture-circle ${r}`]: {
        [`&, &::before, ${r}-thumbnail`]: {
          borderRadius: "50%"
        }
      }
    }
  };
}, u = (i) => {
  const {
    componentCls: e,
    iconCls: t,
    fontSizeLG: l,
    colorTextLightSolid: a
  } = i, o = `${e}-list`, r = `${o}-item`, n = i.uploadPicCardSize;
  return {
    [`
      ${e}-wrapper${e}-picture-card-wrapper,
      ${e}-wrapper${e}-picture-circle-wrapper
    `]: Object.assign(Object.assign({}, p()), {
      display: "inline-block",
      width: "100%",
      [`${e}${e}-select`]: {
        width: n,
        height: n,
        marginInlineEnd: i.marginXS,
        marginBottom: i.marginXS,
        textAlign: "center",
        verticalAlign: "top",
        backgroundColor: i.colorFillAlter,
        border: `${i.lineWidth}px dashed ${i.colorBorder}`,
        borderRadius: i.borderRadiusLG,
        cursor: "pointer",
        transition: `border-color ${i.motionDurationSlow}`,
        [`> ${e}`]: {
          display: "flex",
          alignItems: "center",
          justifyContent: "center",
          height: "100%",
          textAlign: "center"
        },
        [`&:not(${e}-disabled):hover`]: {
          borderColor: i.colorPrimary
        }
      },
      // list
      [`${o}${o}-picture-card, ${o}${o}-picture-circle`]: {
        [`${o}-item-container`]: {
          display: "inline-block",
          width: n,
          height: n,
          marginBlock: `0 ${i.marginXS}px`,
          marginInline: `0 ${i.marginXS}px`,
          verticalAlign: "top"
        },
        "&::after": {
          display: "none"
        },
        [r]: {
          height: "100%",
          margin: 0,
          "&::before": {
            position: "absolute",
            zIndex: 1,
            width: `calc(100% - ${i.paddingXS * 2}px)`,
            height: `calc(100% - ${i.paddingXS * 2}px)`,
            backgroundColor: i.colorBgMask,
            opacity: 0,
            transition: `all ${i.motionDurationSlow}`,
            content: '" "'
          }
        },
        [`${r}:hover`]: {
          [`&::before, ${r}-actions`]: {
            opacity: 1
          }
        },
        [`${r}-actions`]: {
          position: "absolute",
          insetInlineStart: 0,
          zIndex: 10,
          width: "100%",
          whiteSpace: "nowrap",
          textAlign: "center",
          opacity: 0,
          transition: `all ${i.motionDurationSlow}`,
          [`${t}-eye, ${t}-download, ${t}-delete`]: {
            zIndex: 10,
            width: l,
            margin: `0 ${i.marginXXS}px`,
            fontSize: l,
            cursor: "pointer",
            transition: `all ${i.motionDurationSlow}`,
            svg: {
              verticalAlign: "baseline"
            }
          }
        },
        [`${r}-actions, ${r}-actions:hover`]: {
          [`${t}-eye, ${t}-download, ${t}-delete`]: {
            color: new s(a).setAlpha(0.65).toRgbString(),
            "&:hover": {
              color: a
            }
          }
        },
        [`${r}-thumbnail, ${r}-thumbnail img`]: {
          position: "static",
          display: "block",
          width: "100%",
          height: "100%",
          objectFit: "contain"
        },
        [`${r}-name`]: {
          display: "none",
          textAlign: "center"
        },
        [`${r}-file + ${r}-name`]: {
          position: "absolute",
          bottom: i.margin,
          display: "block",
          width: `calc(100% - ${i.paddingXS * 2}px)`
        },
        [`${r}-uploading`]: {
          [`&${r}`]: {
            backgroundColor: i.colorFillAlter
          },
          [`&::before, ${t}-eye, ${t}-download, ${t}-delete`]: {
            display: "none"
          }
        },
        [`${r}-progress`]: {
          bottom: i.marginXL,
          width: `calc(100% - ${i.paddingXS * 2}px)`,
          paddingInlineStart: 0
        }
      }
    }),
    [`${e}-wrapper${e}-picture-circle-wrapper`]: {
      [`${e}${e}-select`]: {
        borderRadius: "50%"
      }
    }
  };
};
export {
  u as genPictureCardStyle,
  m as genPictureStyle
};
