import { FC, ReactElement } from 'react';
import { BitzTabbarItemProps } from './BitzTabbarItem';
import './index.less';
/** Tabbar属性 */
export interface BitzTabbarProps {
    /** 当前选中TabbarItem的name */
    value: string | number;
    /** 组件层级大小 */
    zIndex?: number;
    /** （未开发）是否开启路由模式，路由模式下TabbarItem组件新增to属性 */
    route?: boolean;
    /** 是否固定在底部 */
    fixed?: boolean;
    /** 是否显示top和bottom的border */
    border?: boolean;
    /** 固定在底部时，是否在tab位置生成一个等高的占位元素，生成的元素不能根据placeholder值动态增删 */
    placeholder?: boolean;
    /** 是否添加IOS底部安全距离 */
    safeAreaInsetBottom?: boolean;
    /** value值变化 */
    onChange: (value: string | number) => void;
    /** 存放TabbarItem的地方，建议使用闭合标签 */
    children: ReactElement<BitzTabbarItemProps>[];
}
/** Tabbar Componet */
declare const BitzTabbar: FC<BitzTabbarProps>;
export default BitzTabbar;
