import './index.less';
import { FC, ReactElement, ReactNode } from 'react';
import { UploadProps } from 'antd';
interface IProps extends UploadProps {
    icon?: ReactNode;
    title?: string;
    /**
     * 上传列表的内建样式
     */
    listType?: 'text' | 'picture' | 'picture-card' | 'picture-circle';
    /**
     * 是否显示添加按钮
     */
    showAddBtn?: boolean;
    /**
     * 限制图片类型
     */
    limitImageType?: string[];
    /**
     * 限制文件类型
     */
    limitFileType?: string[];
    /**
     * 限制文件大小，默认限制小于等于20MB
     */
    limitFileSize?: number;
    /**
     * 配置图片裁剪比例， width / height，如：4 / 3
     */
    imgCrop?: {
        aspect?: number;
    };
}
declare const _default: FC<IProps> & {
    Dragger: ({ ...props }: {
        [x: string]: any;
    }) => import("react/jsx-runtime").JSX.Element;
};
export default _default;
export declare function attachPropertiesToComponent<C, P extends Record<string, any>>(component: C, properties: P): C & P;
export declare function ImgCropUplad({ imgCrop, children }: {
    imgCrop?: {
        aspect?: number;
    };
    children: ReactElement;
}): import("react/jsx-runtime").JSX.Element;
